#include <stdio.h>
#include "modules.h"

#include "driver.h"

char *eam_ehello2_unmangled_name = "hello2";
integer_t eam_ehello2_globals_no = 4;

static integer_t integers[3] = { (integer_t)10, (integer_t)20, (integer_t)30};

word_t eam_ehello2_global_1 = (word_t)123456789;
word_t eam_ehello2_global_2 = (word_t)"abcd";
static word_t eam_ehello2_global_3 = (word_t)(integer_t)123;
word_t eam_ehello2_global_4 = (word_t)integers;

void eam_ehello2_initialize(void){
  fprintf(stderr, "[Initializing hello2]\n");
  //  hello22 = eam_load_module("hello22", "libhello22.la");
}

void eam_ehello2_finalize(void){
  fprintf(stderr, "[Finalizing hello2]\n");
  //eam_unload_module(hello22);
}

integer_t eam_ehello2_blocks_no = 3;

EAM_DECLARE_EXPORTED_BLOCK(eam_ehello2_label_1);
EAM_DECLARE_INTERNAL_BLOCK(eam_ehello2_label_2);
EAM_DECLARE_EXPORTED_BLOCK(eam_ehello2_label_3);

EAM_BEGIN_EXPORTED_BLOCK(eam_ehello2_label_1);
  fprintf(stderr, "[block 1 (exported) hello2]\n");
  EAM_FAST_JUMP(eam_ehello2_label_2);
EAM_END_BLOCK

EAM_BEGIN_INTERNAL_BLOCK(eam_ehello2_label_2);
  fprintf(stderr, "[block 2 (internal) hello2]\n");
  EAM_FAST_JUMP(eam_ehello2_label_3);
EAM_END_BLOCK

EAM_BEGIN_EXPORTED_BLOCK(eam_ehello2_label_3);
  fprintf(stderr, "[block 3 (exported) hello2]\n");
  return NULL;
EAM_END_BLOCK

