function warning_about_tests_no(name){
  if (occurrences_no[name] < minimum_tests_no)
    return " [too few tests (" (occurrences_no[name]) ")]";
  else
    return "";
}

BEGIN{
  minimum_tests_no = 3;
}

{ 
  occurrences_no[$1] ++;
  times[$1] = times[$1] + $2;
}

END { 
  for(x in times){
#    print (times[x] / occurrences_no[x]) "\t" x "" ((occurrences_no[x] < minimum_tests_no) ? (" [too few tests (" (occurrences_no[x]) ")]") : "")
    print (times[x] / occurrences_no[x]) "\t" x "" warning_about_tests_no(x)
  }
}
