/* common/config.h.  Generated from config.h.in by configure.  */
/* common/config.h.in.  Generated from configure.ac by autoheader.  */

/* Define if the system can free() blocks allocated with memalign() */
#define CAN_FREE_MEMALIGNED_BLOCKS 1

/* The C compiler */
#define C_CC "gcc-4.2"

/* Compiler options */
#define C_CFLAGS "-rdynamic "

/* The -l options to be supplied when compiling C files */
#define C_LIBS "-lltdl -lpthread -lm -lfl "

/* The installation prefix */
#define C_PREFIX "/home/luca/usr"

/* Configure option --enable-assertions: make expensive integrity checks at
   runtime */
#define ENABLE_ASSERTIONS yes

/* Configure option --enable-assertions-in-generated-code: make expensive
   integrity checks in the runtime-generated C code */
#define ENABLE_ASSERTIONS_IN_GENERATED_CODE yes

/* Configure option --enable-frob-foos: frob every single existing foo */
/* #undef ENABLE_FROB_FOOS */

/* Configure option --enable-verbose-debug: print a lot of debugging
   information at runtime */
/* #undef ENABLE_VERBOSE_DEBUG */

/* Configure option --enable-work-around-libtool-bug: work around what I
   *thought* was a Libtool bug... Now I think it's solved, and it was probably
   my fault */
/* #undef ENABLE_WORK_AROUND_LIBTOOL_BUG */

/* Define to 1 if you have the <dlfcn.h> header file. */
#define HAVE_DLFCN_H 1

/* Define to 1 if you have the <fcntl.h> header file. */
#define HAVE_FCNTL_H 1

/* Define to 1 if you have the <inttypes.h> header file. */
#define HAVE_INTTYPES_H 1

/* Define to 1 if you have the `fl' library (-lfl). */
#define HAVE_LIBFL 1

/* Define to 1 if you have the `l' library (-ll). */
/* #undef HAVE_LIBL */

/* Define to 1 if you have the `ltdl' library (-lltdl). */
#define HAVE_LIBLTDL 1

/* Define to 1 if you have the `m' library (-lm). */
#define HAVE_LIBM 1

/* Define to 1 if you have the `pth' library (-lpth). */
/* #undef HAVE_LIBPTH */

/* Define to 1 if you have the `pthread' library (-lpthread). */
#define HAVE_LIBPTHREAD 1

/* Define to 1 if you have the `pthreads' library (-lpthreads). */
/* #undef HAVE_LIBPTHREADS */

/* Define to 1 if you have the <limits.h> header file. */
#define HAVE_LIMITS_H 1

/* Define to 1 if you have the <malloc.h> header file. */
#define HAVE_MALLOC_H 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if stdbool.h conforms to C99. */
#define HAVE_STDBOOL_H 1

/* Define to 1 if you have the <stddef.h> header file. */
#define HAVE_STDDEF_H 1

/* Define to 1 if you have the <stdint.h> header file. */
#define HAVE_STDINT_H 1

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if cpp supports the ANSI # stringizing operator. */
#define HAVE_STRINGIZE 1

/* Define to 1 if you have the <strings.h> header file. */
#define HAVE_STRINGS_H 1

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/time.h> header file. */
#define HAVE_SYS_TIME_H 1

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have the <unistd.h> header file. */
#define HAVE_UNISTD_H 1

/* Define to 1 if the system has the type `_Bool'. */
#define HAVE__BOOL 1

/* Define to 1 if your C compiler doesn't accept -c and -o together. */
/* #undef NO_MINUS_C_MINUS_O */

/* Name of package */
#define PACKAGE "eAM"

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "bug-epsilon@gnu.org"

/* Define to the full name of this package. */
#define PACKAGE_NAME "The GNU epsilon Abstract Machine"

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "The GNU epsilon Abstract Machine 0.4.0CVS"

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "eAM"

/* Define to the version of this package. */
#define PACKAGE_VERSION "0.4.0CVS"

/* The size of `int', as computed by sizeof. */
#define SIZEOF_INT 4

/* The size of `long', as computed by sizeof. */
#define SIZEOF_LONG 4

/* The size of `long long', as computed by sizeof. */
#define SIZEOF_LONG_LONG 8

/* The size of `short', as computed by sizeof. */
#define SIZEOF_SHORT 2

/* The size of `void *', as computed by sizeof. */
#define SIZEOF_VOID_P 4

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
#define TIME_WITH_SYS_TIME 1

/* Version number of package */
#define VERSION "0.4.0CVS"

/* Configure option --with-readline: use GNU readline for fancy line editing
   */
/* #undef WITH_READLINE */

/* Configure option --with-sdl: use the SDL library for graphics, audio and
   input */
/* #undef WITH_SDL */

/* Define to 1 if your processor stores words with the most significant byte
   first (like Motorola and SPARC, unlike Intel and VAX). */
#define WORDS_BIGENDIAN 1

/* Define to 1 if `lex' declares `yytext' as a `char *' by default, not a
   `char[]'. */
#define YYTEXT_POINTER 1

/* Define to empty if `const' does not conform to ANSI C. */
/* #undef const */

/* Define to `__inline__' or `__inline' if that's what the C compiler
   calls it, or to nothing if 'inline' is not supported under any name.  */
#ifndef __cplusplus
/* #undef inline */
#endif

/* Define to `unsigned int' if <sys/types.h> does not define. */
/* #undef size_t */
